1. Create an Authorisation Transaction
You can create an authorisation transaction using the Razorpay Standard Checkout or using a Registration Link.1.1. Using Razorpay Standard Checkout
To create an authorisation transaction using the Razorpay Standard Checkout, you need to:1
[Create a Customer](#111-create-a-customer).
2
[Create an Order](#112-create-an-order).
3
[Create Authorisation Payment using Razorpay Standard Checkout](#11...
1.1.1. Create a Customer
Razorpay links recurring tokens to customers using a unique identifier generated through the Customer API. You can create customers with basic information such asemail and contact and use them for various Razorpay offerings. The following endpoint creates a customer.
/customers
Curl
Response
Request Parameters
name
: string The name of the customer. For example, Gaurav Kumar.
email
: string The email address of the customer. For example, gaurav.kumar@example.com.
contact
: string The phone number of the customer. For example, 9876543210.
fail_existing optional
: string The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter fail_existing to get the existing customer’s details in the response. Possible values:
1(default): If a customer with the same details already exists, throws an error.0: If a customer with the same details already exists, fetches details of the existing customer.
notes optional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
Response Parameters
id
: string The unique identifier of the customer. For example cust_1Aa00000000001.
entity
: string The name of the entity. Here, it is customer.
name
: string The name of the customer. For example, Gaurav Kumar.
email
: string The email address of the customer. For example, gaurav.kumar@example.com.
contact
: string The phone number of the customer. For example, 9876543210.
notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
created_at
: integer A Unix timestamp, at which the customer was created.
You can create an order once you create a customer for the payment authorisation.
1.1.2. Create an Order
Use the Orders API to create a unique Razorpayorder_id that is associated with the authorisation transaction. The following endpoint creates an order.
/orders
Curl
Response
Curl
Response
Curl
Response
Request Parameters
amount mandatory
: integer Amount in currency subunits. For emandate, the amount should be 0.
currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
payment_capture mandatory
: boolean Determines whether the payment status should be changed to captured automatically or not. Possible values:
true: Payments are captured automatically.false: Payments are not captured automatically. You can manually capture payments using the Manually Capture Payments API.
method mandatory
: string The authorisation method. Here, it is emandate.
customer_id mandatory
: string The unique identifier of the customer to be charged. For example, cust_D0cs04OIpPPU1F.
receipt optional
: string A user-entered unique identifier of the order. For example, rcptid #1. You should map this parameter to the order_id sent by Razorpay.
notesoptional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
token
: object Details related to the authorization such as max amount and bank account information. Pass a value in the first_payment_amount parameter if you want to auto-charge the customer the first payment immediately after mandate authorisation. The first payment amount will be debited, with a new order_id and corresponding payment_id created automatically and executed within 2 days of emandate token confirmation.
first_payment_amount optional
: integer The amount, in paise, that should be auto-charged in addition to the authorization amount. For example, 100000.
auth_type optional
: string The payment method used to make the authorisation transaction. Possible values:
netbankingdebitcardaadhaar
max_amount optional
: integer The maximum amount, in paise, that a customer can be charged in one transaction. Know about maximum and default values.
expire_at optional
: integer The Unix timestamp, till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. The default value is 10 years for emandate. This value can range from the current date to 31-12-2099 (4102444799).
notesoptional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
bank_account
: object The customer’s bank account details that should be pre-filled on the checkout.
account_number optional
: string The customer’s bank account number.
account_type optional
: string The customer’s bank account type. Possible values:
savings(default)current
ifsc_code optional
: string The customer’s bank IFSC. For example UTIB0000001.
beneficiary_name optional
: string The customer’s name. For example, Gaurav Kumar.
Response Parameters
id
: string A unique identifier of the order created. For example order_1Aa00000000001.
entity
: string The entity that has been created. Here it is order.
amount
: integer Amount in currency subunits. For emandate, the amount should be 0.
amount_paid
: integer The amount that has been paid.
amount_due
: integer The amount that is yet to pay.
currency
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
receipt
: string A user-entered unique identifier of the order. For example, rcptid #1. You should map this parameter to the order_id sent by Razorpay.
status
: string The status of the order.
notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
created_at
: integer The Unix timestamp at which the order was created.
token
: object Details related to the authorisation such as max amount and bank account information.
auth_type
: string Emandate type used to make the authorisation payment. Possible values:
netbankingdebitcardaadhaar
max_amount
: integer The maximum amount in paise a customer can be charged in a transaction. Know about the maximum and default values.
expire_at
: integer The Unix timestamp to indicate till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. The default value is 10 years for emandate. This value can range from the current date to 31-12-2099 (4102444799).
notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
bank_account
: object Customer’s bank account details that should be pre-filled on the checkout.
account_number
: string Customer’s bank account number.
account_type
: string Customer’s bank account type. Possible values:
savings(default)current
ifsc_code
: string Customer’s bank IFSC. For example UTIB0000001.
beneficiary_name
: string Name of the beneficiary. For example, Gaurav Kumar.
1.1.3. Create an Authorisation Payment
Create a payment checkout form for customers to make Authorisation Transaction and register their mandate. You can use the Handler Function or Callback URL.Handler Function | Callback URL
When you use the handler function, the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature) is submitted to the Checkout Form. You need to collect these and send them to your server. | When you use a Callback URL, the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature) is submitted to the Callback URL.
Additional Checkout Fields
customer_id mandatory
: string Unique identifier of the customer created in the first step.
order_id mandatory
: string Unique identifier of the order created in the second step.
1.2. Using a Registration Link
Registration Link is an alternate way of creating an authorisation transaction. You can create a registration link using the API or Dashboard.Handy Tips
- When you create a registration link, an invoice is automatically issued to the customer. They can use this invoice to make the authorisation payment.
- A registration link should always have an order amount (in paise) the customer will be charged when making the authorisation payment. This amount should be
0in the case of Emandate.
Handy Tips
1.2.1. Create a Registration Link
The following endpoint creates a registration link. /subscription_registration/auth_linksCurl
Response
Curl
Response
Curl
Response
Request Parameters
customer
: object Details of the customer to whom the registration link is sent.
name mandatory
: string Customer’s name.
email mandatory
: string Customer’s email address.
contactmandatory
: integer Customer’s contact number.
type mandatory
: string In this case, the value is link.
amount mandatory
: integer The payment amount in the smallest currency sub-unit.
currency mandatory
: string The 3-letter ISO currency code for the payment.
description mandatory
: string A description that appears on the hosted page.
subscription_registration
: object Details of the authorisation payment.
method mandatory
: string The authorization method. Here, it is emandate.
auth_type optional
: string Possible values:
netbankingdebitcardaadhaar
first_payment_amount optional
: integer The amount, in paise, the customer should be auto-charged in addition to the authorisation amount. For example, 100000. Pass a value in the first_payment_amount parameter if you want to auto-charge the customer the first payment immediately after mandate authorisation. The first payment amount will be debited, with a new order_id and corresponding payment_id created automatically and executed within 2 days of emandate token confirmation.
max_amount optional
: integer The maximum amount, in paise, a customer can be charged in a transaction. Know about maximum and default values.
expire_at optional
: integer The Unix timestamp indicates till when you can use the token (authorization on the payment method) to charge the customer their subsequent payments. Defaults to 40 years. The maximum value you can set is 40 years from the current date. Any value beyond this will throw an error.
bank_account
: object The customer’s bank account details.
beneficiary_name optional
: string Name on the beneficiary. For example Gaurav Kumar.
Response Parameters
id
: string The unique identifier of the invoice.
entity
: string The entity that has been created. Here, it is invoice.
receipt
: string A user-entered unique identifier of the invoice.
invoice_number
: string Unique number you added for internal reference.
customer_id
: string The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.
customer_details
: object Details of the customer.
id
: string The unique identifier associated with the customer to whom the invoice has been issued.
name
: string The customer’s name.
email
: string The customer’s email address.
contact
: integer The customer’s phone number.
billing_address
: string Details of the customer’s billing address.
shipping_address
: string Details of the customer’s shipping address.
order_id
: string The unique identifier of the order associated with the invoice.
line_items
: string Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.
payment_id
: string Unique identifier of a payment made against the invoice.
status
: string The status of the invoice. Possible values:
draftissuedpartially_paidpaidcancelledexpireddeleted
expire_by
: integer The Unix timestamp at which the invoice will expire.
issued_at
: integer The Unix timestamp at which the invoice was issued to the customer.
paid_at
: integer The Unix timestamp at which the payment was made.
cancelled_at
: integer The Unix timestamp at which the invoice was cancelled.
expired_at
: integer The Unix timestamp at which the invoice expired.
sms_status
: string The delivery status of the SMS notification for the invoice sent to the customer. Possible values:
pendingsent
email_status
: string The delivery status of the email notification for the invoice sent to the customer. Possible values:
pendingsent
date
: integer Timestamp, in Unix format, that indicates the issue date of the invoice.
terms
: string Any terms to be included in the invoice. Maximum of 2048 characters.
partial_payment
: boolean Indicates whether the customer can make a partial payment on the invoice. Possible values:
true: The customer can make partial payments.false(default): The customer cannot make partial payments.
amount
: integer Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is 299.95, pass the value as 29995.
amount_paid
: integer Amount paid by the customer against the invoice.
amount_due
: integer The remaining amount to be paid by the customer for the issued invoice.
currency
: string The currency associated with the invoice.
description
: string A brief description of the invoice.
notes
: object Any custom notes added to the invoice. Maximum of 2048 characters.
short_url
: string The short URL that is generated. This is the link that can be shared with the customer to receive payments.
type
: string Here, it is invoice.
comment
: string Any comments to be added in the invoice. Maximum of 2048 characters.
1.2.2. Send/Resend Notifications
The following endpoint sends/resends notifications with the short URL to the customer: /invoices/:id/notify_by/:mediumCurl
Response
Path Parameters
idmandatory
: string The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, inv_1Aa00000000001.
medium mandatory
: string Determines through which medium you want to resend the notification. Possible values:
smsemail
Response Parameters
success
: boolean Indicates whether the notifications were sent successfully. Possible values:
true: The notifications were successfully sent via SMS, email or both.false: The notifications were not sent.
1.2.3. Cancel a Registration Link
The following endpoint cancels a registration link. /invoices/:id/cancelHandy Tips
issued state.
Curl
Response
Path Parameter
id mandatory
: string The unique identifier for the invoice linked to the registration link that you want to cancel. For example, inv_1Aa00000000001.
Response Parameters
id
: string The unique identifier of the invoice.
entity
: string The entity that has been created. Here, it is invoice.
receipt
: string A user-entered unique identifier of the invoice.
invoice_number
: string Unique number you added for internal reference.
customer_id
: string The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.
customer_details
: object Details of the customer.
id
: string The unique identifier associated with the customer to whom the invoice has been issued.
name
: string The customer’s name.
email
: string The customer’s email address.
contact
: integer The customer’s phone number.
billing_address
: string Details of the customer’s billing address.
shipping_address
: string Details of the customer’s shipping address.
order_id
: string The unique identifier of the order associated with the invoice.
line_items
: string Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.
payment_id
: string Unique identifier of a payment made against the invoice.
status
: string The status of the invoice. Possible values:
draftissuedpartially_paidpaidcancelledexpireddeleted
expire_by
: integer The Unix timestamp at which the invoice will expire.
issued_at
: integer The Unix timestamp at which the invoice was issued to the customer.
paid_at
: integer The Unix timestamp at which the payment was made.
cancelled_at
: integer The Unix timestamp at which the invoice was cancelled.
expired_at
: integer The Unix timestamp at which the invoice expired.
sms_status
: string The delivery status of the SMS notification for the invoice sent to the customer. Possible values:
pendingsent
email_status
: string The delivery status of the email notification for the invoice sent to the customer. Possible values:
pendingsent
date
: integer Timestamp, in Unix format, that indicates the issue date of the invoice.
terms
: string Any terms to be included in the invoice. Maximum of 2048 characters.
partial_payment
: boolean Indicates whether the customer can make a partial payment on the invoice. Possible values:
true: The customer can make partial payments.false(default): The customer cannot make partial payments.
amount
: integer Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is 299.95, pass the value as 29995.
amount_paid
: integer Amount paid by the customer against the invoice.
amount_due
: integer The remaining amount to be paid by the customer for the issued invoice.
currency
: string The currency associated with the invoice.
description
: string A brief description of the invoice.
notes
: object Any custom notes added to the invoice. Maximum of 2048 characters.
short_url
: string The short URL that is generated. This is the link that can be shared with the customer to receive payments.
type
: string Here, it is invoice.
comment
: string Any comments to be added in the invoice. Maximum of 2048 characters.
2. Fetch and Manage Tokens
Once you capture a payment, Razorpay Checkout returns arazorpay_payment_id. You can use this id to fetch the token_id, which is used to create and charge subsequent payments.
You can retrieve the token_id using the Dashboard or the APIs given below.
Know more about Tokens.
2.1. Fetch Token by Payment id
The following endpoint retrieves thetoken_id using a payment_id.
/payments/:id
Curl
Response
Handy Tips
token_id via the payment.authorized webhook.
Path Parameter
id mandatory
: string The unique identifier of the payment to be retrieved. For example, pay_1Aa00000000002.
Response Parameters
id
: string Unique identifier of the payment.
entity
: string Indicates the type of entity. Here, it is payment.
amount
: integer The payment amount represented in smallest unit of the currency passed. For example, amount = 100 translates to 100 subunits, that is 1.
currency
: string The currency in which the payment is made. Refer to the list of international currencies that we support.
status
: string The status of the payment. Possible values:
createdauthorizedcapturedrefundedfailed
order_id
: string The unique identifier of the order.
invoice_id
: string The unique identifier of the invoice.
international
: boolean Indicates whether the payment is done via an international card or a domestic one. Possible values:
true: Payment made using international card.false: Payment not made using international card.
method
: string The payment method used for making the payment. Possible values:
cardnetbankingwalletemiupi
amount_refunded
: integer The amount refunded in smallest unit of the currency passed.
refund_status
: string The refund status of the payment. Possible values:
nullpartialfull
captured
: boolean Indicates if the payment is captured. Possible values:
true: Payment has been captured.false: Payment has not been captured.
description
: string Description of the payment, if any.
email
: string Customer email address used for the payment.
contact
: integer Customer contact number used for the payment.
customer_id
: string The unique identifier of the customer.
token_id
: string The unique identifier of the token.
notes
: json object Contains user-defined fields, stored for reference purposes.
fee
: integer Fee (including GST) charged by Razorpay.
tax
: integer GST charged for the payment.
error_code
: string Error that occurred during payment. For example, BAD_REQUEST_ERROR.
error_description
: string Description of the error that occurred during payment. For example, Payment processing failed because of incorrect OTP.
error_source
: string The point of failure. For example, customer.
error_step
: string The stage where the transaction failure occurred. The stages can vary depending on the payment method used to complete the transaction. For example, payment_authentication.
error_reason
: string The exact error reason. For example, incorrect_otp.
created_at
: integer Timestamp, in UNIX format, on which the payment was created.
2.2. Fetch Tokens by Customer id
A customer can have multiple tokens and these tokens can be used to create subsequent payments for multiple products or services. The following endpoint retrieves tokens linked to a customer.Path Parameter
id mandatory
: string The unique identifier of the customer for whom tokens are to be retrieved. For example, cust_1Aa00000000002.
Response Parameters
entity
: string The entity being created. Here, it is a collection.
count
: integer The number of tokens to be fetched.
items
: object Details related to token such as token id and bank information.
id
: string The unique identifier linked to an item. In this example, it is token_id.
entity
: string The entity being created. Here, it is a token.
token
: string The token is being fetched.
bank
: string Card issuing bank details.
wallet
: string Provides wallet information.
method
: string The payment method used to make the transaction.
card
: object Details related to card used to make the transaction.
entity
: string The entity being created. Here, it is card.
name
: string Name of the cardholder.
last4
: integer Last 4 digits of the card.
network
: string Name of the payment processor. Here it is Visa.
type
: string Card type (debit or credit). In this example, it is credit.
issuer
: string Name of the card-issuing bank.
international
: boolean Card usage restriction. Possible values:
true: Supports international transactions.false: International transactions are not supported.
emi
: string Card EMI status. Possible values.
true: The card is on EMI.false: The card is not on EMI.
sub_type
: string Type of the customer.
expiry_month
: integer Month on which the card expires.
expiry_year
: integer Year on which the card expires.
flows
: object The transaction flow details.
otp
: string Whether the OTP function is enabled or not. Possible values:
true: The OTP function is enabled.false: The OTP function is not enabled.
recurring
: string Whether the recurring for this payment method is enabled or not. Possible Values:
true: Recurring is enabled.false: Recurring is not enabled.
vpa
: object The VPA details.
username
: string The username of the VPA holder. For example, gaurav.kumar.
handle
: string The VPA handle. Here it is upi.
name
: string The name of the VPA holder.
recurring
: string This represents whether recurring is enabled for this token. Possible values:
true: Recurring is enabled.false: Recurring is not enabled.
recurring_details
: object Details of the recurring transaction.
status
: string This represents the status of the recurring transaction. Possible values:
initiatedconfirmedrejectedcancelledpaused
failure_reason
: string This provides the reason why the recurring transaction failed.
auth_type
: string The authorisation type details.
mrn
: string The unique identifier issued by the payment gateway during customer registration. This can be Gateway Reference Number or Gateway Token.
used_at
: integer The VPA usage timestamp.
created_at
: integer The token creation timestamp.
expired_at
: integer The token expiry date timestamp.
dcc_enabled
: string Indicates whether the option to change currency is enabled or not. Possible values.
true: The option to change currency is enabledfalse: The option to change currency is not enabled.
2.3. Delete Tokens
The following endpoint deletes a token. /customers/:customer_id/tokens/:token_idCurl
Response
Path Parameter
customer_id mandatory
: string The unique identifier of the customer with whom the token is linked. For example, cust_1Aa00000000002.
token_id mandatory
: string The unique identifier of the token that is to be deleted. For example, token_1Aa00000000001.
Response Parameters
deleted
: boolean Indicates whether the token is deleted. Possible values:
true: The token is deleted successfully.false: The token was not deleted.
3. Create Subsequent Payments
You should perform the following steps to create and charge your customer subsequent payments:3.1. Create an Order to Charge the Customer
You have to create a new order every time you want to charge your customers. This order is different from the one created during the authorisation transaction. The following endpoint creates an order. /ordersCurl
Success Response
Request Parameters
amount mandatory
: integer Amount in currency subunits.
currency mandatory
: string The 3-letter ISO currency code for the payment.
receipt optional
: string A user-entered unique identifier for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.
notes optional
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.
payment_capture mandatory
: boolean Determines whether the payment status should be changed to captured automatically or not. Possible values:
true: Payments are captured automatically.false: Payments are not captured automatically. You can manually capture payments using the Manually Capture Payments API.
Response Parameters
id
: string A unique identifier of the order created. For example order_1Aa00000000001.
entity
: string The entity that has been created. Here it is order.
amount
: integer Amount in currency subunits.
amount_paid
: integer The amount that has been paid.
amount_due
: integer The amount that is yet to pay.
currency
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
receipt
: string A user-entered unique identifier of the order. For example, rcptid #1.
status
: string The status of the order.
notes
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.
created_at
: integer The Unix timestamp at which the order was created.
3.2. Create a Recurring Payment
Once you have generated anorder_id, use it with the token_id to create a payment and charge the customer. The following endpoint creates a payment to charge the customer.
/payments/create/recurring
Curl
Success Response
Request Parameters
amount mandatory
: integer The amount you want to charge your customer. This should be the same as the order amount.
order_idmandatory
: string The unique identifier of the order created. For example, order_1Aa00000000002.
customer_id mandatory
: string The unique identifier of the customer you want to charge. For example, cust_1Aa00000000002.
token mandatory
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.
recurring mandatory
: boolean Determines whether recurring payment is enabled or not.
true: Recurring payment is enabled.false: Recurring payment is not enabled.
notesoptional
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.
Response Parameter
razorpay_payment_id
: string The unique identifier of the payment that is created. For example, pay_1Aa00000000001.